<?php
/**
 * Created by PhpStorm.
 * User: usuario1
 * Date: 12/10/2017
 * Time: 02:00 PM
 */

class daoCursorIterator implements Iterator{

    private $cursor;
    private $current;
    private $index;

    /**
     * daoResponseIterator constructor.
     */
    public function __construct($cursor) {
        $this->cursor = $cursor;
    }

    public function current() {
        if(!isset($this->current)) $this->next();
        return $this->current;
    }

    public function next() {
        $this->current = $this->cursor->fetchRow(MDB2_FETCHMODE_ASSOC);
        $this->index++;
        return $this->current;
    }

    public function key() {
        return $this->index;
    }

    public function valid() {
        return (! MDB2::isError($this->cursor) && $this->current) ;
    }

    public function rewind() {
        $this->index= -1;
        $this->next();
    }

}